package com.rjconsultores.ventaboletos.dao;

import java.util.Date;
import java.util.List;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.OperadorEmbarcada;
import com.rjconsultores.ventaboletos.entidad.OperadorEmbarcadaServico;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.vo.corrida.CorridaVO;

@SuppressWarnings("rawtypes")
public interface OperadorEmbarcadaServicoDAO extends GenericDAO<OperadorEmbarcadaServico, Long> {
	
	public List<OperadorEmbarcadaServico> buscarPorOperador(OperadorEmbarcada operador);	
//	public OperadorEmbarcada buscarOperadorEmbarcadaPorUsuario(Integer idUsuario);

	public List<CorridaVO> getListaCorridaVO(Integer operador, Empresa empresa, Date dtIni, Date dtFim, PuntoVenta puntoVenta);
	
	public List getListaResumidaCorridaVO(Integer operador, Empresa empresa, Date dtIni, Date dtFim, PuntoVenta puntoVenta, Boolean retornaTramos) throws Exception ;
	
	public List<CorridaVO> getListaCorridaProxyVO(Integer operador, Empresa empresa, Date dtIni, Date dtFim);

	public void preencherCorrida(CorridaVO corrida, PuntoVenta puntoVenta, Empresa empresa);
}
