package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "CASETA_PEAJE_EXCEPCION_SEQ", sequenceName = "CASETA_PEAJE_EXCEPCION_SEQ", allocationSize = 1)
@Table(name = "CASETA_PEAJE_EXCEPCION")
public class CasetaPeajeExcepcion implements Serializable, Comparable<CasetaPeajeExcepcion>  {

private static final long serialVersionUID = 1L;
	
	@Id
	@Basic(optional = false)
	@Column(name = "CASETAPEAJEEXCEPCION_ID")
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "CASETA_PEAJE_EXCEPCION_SEQ")
	private Integer casetaPeajeExcepcionId;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	@ManyToOne
	@JoinColumn(name = "CASETAPEAJE_ID" , referencedColumnName = "CASETAPEAJE_ID")
	private CasetaPeaje casetaPeaje;
	@Column(name = "FECHAVENTAINI")
    @Temporal(TemporalType.TIMESTAMP)
    private java.util.Date fecVentaIni;
	@Column(name = "FECHAVENTAFIN")
    @Temporal(TemporalType.TIMESTAMP)
    private java.util.Date fecVentaFin;
    @Column(name = "FECHORINICIO")
	@Temporal(TemporalType.TIME)
	private Date horaIni;
	@Column(name = "FECHORFINAL")
   	@Temporal(TemporalType.TIME)
   	private Date horaFin;
	@Column(name = "INDLUNES")
	private Boolean INDLUNES;
	@Column(name = "INDMARTES")
	private Boolean INDMARTES;
	@Column(name = "INDMIERCOLES")
	private Boolean INDMIERCOLES;
	@Column(name = "INDJUEVES")
	private Boolean INDJUEVES;
	@Column(name = "INDVIERNES")
	private Boolean INDVIERNES;
	@Column(name = "INDSABADO")
	private Boolean INDSABADO;
	@Column(name = "INDDOMINGO")
	private Boolean INDDOMINGO;
	@Column(name = "PRECIO")
    private BigDecimal precio;
	
	
	public Integer getCasetaPeajeExcepcionId() {
		return casetaPeajeExcepcionId;
	}
	public void setCasetaPeajeExcepcionId(Integer casetaPeajeExcepcionId) {
		this.casetaPeajeExcepcionId = casetaPeajeExcepcionId;
	}
	public Boolean getActivo() {
		return activo;
	}
	public void setActivo(Boolean activo) {
		this.activo = activo;
	}
	public Date getFecmodif() {
		return fecmodif;
	}
	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}
	public Integer getUsuarioId() {
		return usuarioId;
	}
	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}
	public CasetaPeaje getCasetaPeaje() {
		return casetaPeaje;
	}
	public void setCasetaPeaje(CasetaPeaje casetaPeaje) {
		this.casetaPeaje = casetaPeaje;
	}
	public java.util.Date getFecVentaIni() {
		return fecVentaIni;
	}
	public void setFecVentaIni(java.util.Date fecVentaIni) {
		this.fecVentaIni = fecVentaIni;
	}
	public java.util.Date getFecVentaFin() {
		return fecVentaFin;
	}
	public void setFecVentaFin(java.util.Date fecVentaFin) {
		this.fecVentaFin = fecVentaFin;
	}
	public Date getHoraIni() {
		return horaIni;
	}
	public void setHoraIni(Date horaIni) {
		this.horaIni = horaIni;
	}
	public Date getHoraFin() {
		return horaFin;
	}
	public void setHoraFin(Date horaFin) {
		this.horaFin = horaFin;
	}
	public Boolean getINDLUNES() {
		return INDLUNES;
	}
	public void setINDLUNES(Boolean iNDLUNES) {
		INDLUNES = iNDLUNES;
	}
	public Boolean getINDMARTES() {
		return INDMARTES;
	}
	public void setINDMARTES(Boolean iNDMARTES) {
		INDMARTES = iNDMARTES;
	}
	public Boolean getINDMIERCOLES() {
		return INDMIERCOLES;
	}
	public void setINDMIERCOLES(Boolean iNDMIERCOLES) {
		INDMIERCOLES = iNDMIERCOLES;
	}
	public Boolean getINDJUEVES() {
		return INDJUEVES;
	}
	public void setINDJUEVES(Boolean iNDJUEVES) {
		INDJUEVES = iNDJUEVES;
	}
	public Boolean getINDVIERNES() {
		return INDVIERNES;
	}
	public void setINDVIERNES(Boolean iNDVIERNES) {
		INDVIERNES = iNDVIERNES;
	}
	public Boolean getINDSABADO() {
		return INDSABADO;
	}
	public void setINDSABADO(Boolean iNDSABADO) {
		INDSABADO = iNDSABADO;
	}
	public Boolean getINDDOMINGO() {
		return INDDOMINGO;
	}
	public void setINDDOMINGO(Boolean iNDDOMINGO) {
		INDDOMINGO = iNDDOMINGO;
	}
	public BigDecimal getPrecio() {
		return precio;
	}
	public void setPrecio(BigDecimal precio) {
		this.precio = precio;
	}
	@Override
	public int compareTo(CasetaPeajeExcepcion o) {
		if(o.getCasetaPeajeExcepcionId() != null){
			return this.getCasetaPeajeExcepcionId().intValue() - o.getCasetaPeajeExcepcionId().intValue();
		}else{
			return -1;
		}
	}
	
	@Override
    public int hashCode() {
    	int hash = 0;
    	hash += casetaPeajeExcepcionId != null ? casetaPeajeExcepcionId.hashCode() : 0;
    	return hash;
    }
    
    @Override
    public boolean equals(Object object) {
        if (!(object instanceof CasetaPeajeExcepcion)) {
            return false;
        }
        CasetaPeajeExcepcion other = (CasetaPeajeExcepcion) object;
        if ((this.casetaPeajeExcepcionId == null && other.casetaPeajeExcepcionId != null) || (this.casetaPeajeExcepcionId != null && !this.casetaPeajeExcepcionId.equals(other.casetaPeajeExcepcionId))) {
            return false;
        }
        return true;
    }
    
}
