package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "COMISSAO_LOG_SEQ", sequenceName = "COMISSAO_LOG_SEQ", allocationSize = 1)
@Table(name = "COMISSAO_LOG")
public class ComissaoLog implements Serializable {
	
	private static final long serialVersionUID = 1L;

	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "COMISSAO_LOG_SEQ")
	@Column(name = "COMISSAOLOG_ID")
	private Long comissaologId;
	
	@Column(name = "PUNTOVENTA_ID")
	private Integer puntoventaId;
	
	@Column(name = "EMPRESA_ID")
	private Integer empresaId;
	
	@Column(name = "ACTIVO")
	private Boolean activo;
	
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	
	@Column(name = "FECCORTE")
	@Temporal(TemporalType.DATE)
	private Date feccorte;
	
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;

	@Column(name = "TURNO_ID")
	private Integer turnoId;
	
	@Column(name = "CAJA_ID")
	private Long cajaId;
	
	@Column(name = "CAJADIVERSOS_ID")
	private Long cajadiversosId;
	
	@Column(name = "PORC_COMISSAO")
	private BigDecimal porcComissao;
	
	@Column(name = "VALOR_BASE")
	private BigDecimal valorBase;
	
	@Column(name = "VALOR_COMISSAO")
	private BigDecimal valorComissao;
	
	@Column(name = "ORIGEM")
	private String origem;
	
	@Column(name = "TEXTO")
	private String texto;

	public Long getComissaologId() {
		return comissaologId;
	}

	public void setComissaologId(Long comissaologId) {
		this.comissaologId = comissaologId;
	}

	public Integer getPuntoventaId() {
		return puntoventaId;
	}

	public void setPuntoventaId(Integer puntoventaId) {
		this.puntoventaId = puntoventaId;
	}

	public Integer getEmpresaId() {
		return empresaId;
	}

	public void setEmpresaId(Integer empresaId) {
		this.empresaId = empresaId;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Date getFeccorte() {
		return feccorte;
	}

	public void setFeccorte(Date feccorte) {
		this.feccorte = feccorte;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public Integer getTurnoId() {
		return turnoId;
	}

	public void setTurnoId(Integer turnoId) {
		this.turnoId = turnoId;
	}

	public Long getCajaId() {
		return cajaId;
	}

	public void setCajaId(Long cajaId) {
		this.cajaId = cajaId;
	}

	public Long getCajadiversosId() {
		return cajadiversosId;
	}

	public void setCajadiversosId(Long cajadiversosId) {
		this.cajadiversosId = cajadiversosId;
	}

	public BigDecimal getPorcComissao() {
		return porcComissao;
	}

	public void setPorcComissao(BigDecimal porcComissao) {
		this.porcComissao = porcComissao;
	}

	public BigDecimal getValorBase() {
		return valorBase;
	}

	public void setValorBase(BigDecimal valorBase) {
		this.valorBase = valorBase;
	}

	public BigDecimal getValorComissao() {
		return valorComissao;
	}

	public void setValorComissao(BigDecimal valorComissao) {
		this.valorComissao = valorComissao;
	}

	public String getOrigem() {
		return origem;
	}

	public void setOrigem(String origem) {
		this.origem = origem;
	}

	public String getTexto() {
		return texto;
	}

	public void setTexto(String texto) {
		this.texto = texto;
	}
	
}
