package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name = "conf_contrato_puntoVenta")
@SequenceGenerator(name = "CONFCONTRATOPUNTOVENTA_SEQ", sequenceName = "CONFCONTRATOPUNTOVENTA_SEQ", allocationSize = 1)
public class ConfContratoPuntoVenta implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "CONFCONTRATOPUNTOVENTA_SEQ")
	@Column(name = "CONF_CONTRATO_PUNTOVENTA_ID")
	private Integer confContratoPuntoVentaId;

	@Column(name = "ACTIVO")
	private Boolean activo;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "FECMODIF")
	private Date fecmodif;

	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	
	@Column(name = "TEXTOCONTRATOAVISTA")
	private String textoContratoAVista;
	@Column(name = "TEXTOCONTRATOPRAZO")
	private String textoContratoPrazo;

	public Integer getConfigContratoPuntoVentaId() {
		return confContratoPuntoVentaId;
	}

	public void setConfContratoPuntoVentaId(Integer confContratoPuntoVentaId) {
		this.confContratoPuntoVentaId = confContratoPuntoVentaId;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}



	public String getTextoContratoAVista() {
		return textoContratoAVista;
	}

	public void setTextoContratoAVista(String textoContratoAVista) {
		this.textoContratoAVista = textoContratoAVista;
	}

	public String getTextoContratoPrazo() {
		return textoContratoPrazo;
	}

	public void setTextoContratoPrazo(String textoContratoPrazo) {
		this.textoContratoPrazo = textoContratoPrazo;
	}

	public Integer getConfContratoPuntoVentaId() {
		return confContratoPuntoVentaId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((confContratoPuntoVentaId == null) ? 0 : confContratoPuntoVentaId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		ConfContratoPuntoVenta other = (ConfContratoPuntoVenta) obj;
		if (confContratoPuntoVentaId == null) {
			if (other.confContratoPuntoVentaId != null)
				return false;
		} else if (!confContratoPuntoVentaId.equals(other.confContratoPuntoVentaId))
			return false;
		return true;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

}
