package com.rjconsultores.ventaboletos.entidad;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "CONFIGURACION_PRODUCTO_SEQ", sequenceName = "CONFIGURACION_PRODUCTO_SEQ", allocationSize = 1)
@Table(name = "CONFIGURACION_PRODUCTO")
public class ConfiguracionProducto {

	@Id
	@Basic(optional = false)
	@Column(name = "CONFIGURACIONPRODUCTO_ID")
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "CONFIGURACION_PRODUCTO_SEQ")
	private Long configuracionProductoId;
	@ManyToOne
	@JoinColumn(name = "TIPOEVENTOEXTRA_ID")
	private TipoEventoExtra tipoeventoextra;
	@Column(name = "PRECIO")
	private BigDecimal precio;
	@Column(name = "FECVIGENCIAINICIAL")
	@Temporal(TemporalType.DATE)
	private Date fecVigenciaInicial;
	@Column(name = "FECVIGENCIAFINAL")
	@Temporal(TemporalType.DATE)
	private Date fecVigenciaFinal;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	
	public Long getConfiguracionProductoId() {
		return configuracionProductoId;
	}
	public void setConfiguracionProductoId(Long configuracionProductoId) {
		this.configuracionProductoId = configuracionProductoId;
	}
	public TipoEventoExtra getTipoeventoextra() {
		return tipoeventoextra;
	}
	public void setTipoeventoextra(TipoEventoExtra tipoeventoextra) {
		this.tipoeventoextra = tipoeventoextra;
	}
	public BigDecimal getPrecio() {
		return precio;
	}
	public void setPrecio(BigDecimal precio) {
		this.precio = precio;
	}
	public Date getFecVigenciaInicial() {
		return fecVigenciaInicial;
	}
	public void setFecVigenciaInicial(Date fecVigenciaInicial) {
		this.fecVigenciaInicial = fecVigenciaInicial;
	}
	public Date getFecVigenciaFinal() {
		return fecVigenciaFinal;
	}
	public void setFecVigenciaFinal(Date fecVigenciaFinal) {
		this.fecVigenciaFinal = fecVigenciaFinal;
	}
	public Boolean getActivo() {
		return activo;
	}
	public void setActivo(Boolean activo) {
		this.activo = activo;
	}
	public Date getFecmodif() {
		return fecmodif;
	}
	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}
	public Integer getUsuarioId() {
		return usuarioId;
	}
	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}
	
	
}
