package com.rjconsultores.ventaboletos.entidad;

import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "CONFIG_PRODUCTO_PARADA_SEQ", sequenceName = "CONFIG_PRODUCTO_PARADA_SEQ", allocationSize = 1)
@Table(name = "CONFIGURACION_PRODUCTO_PARADA")
public class ConfiguracionProductoParada {

	@Id
	@Basic(optional = false)
	@Column(name = "CONF_PRODUCTO_PARADA_ID")
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "CONFIG_PRODUCTO_PARADA_SEQ")
	private Long configuracionProductoParadaId;
	@ManyToOne
	@JoinColumn(name = "CONFIGURACIONPRODUCTO_ID")
	private ConfiguracionProducto configuracionProducto;
	@JoinColumn(name = "PARADA_ID", referencedColumnName = "PARADA_ID")
	@ManyToOne
	private Parada paradaId;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "ACTIVO")
	private Boolean activo;
	
	public Long getConfiguracionProductoParadaId() {
		return configuracionProductoParadaId;
	}
	public void setConfiguracionProductoParadaId(Long configuracionProductoParadaId) {
		this.configuracionProductoParadaId = configuracionProductoParadaId;
	}
	public ConfiguracionProducto getConfiguracionProducto() {
		return configuracionProducto;
	}
	public void setConfiguracionProducto(ConfiguracionProducto configuracionProducto) {
		this.configuracionProducto = configuracionProducto;
	}

	public Parada getParadaId() {
		return paradaId;
	}
	public void setParadaId(Parada paradaId) {
		this.paradaId = paradaId;
	}
	public Integer getUsuarioId() {
		return usuarioId;
	}
	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}
	public Date getFecmodif() {
		return fecmodif;
	}
	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}
	public Boolean getActivo() {
		return activo;
	}
	public void setActivo(Boolean activo) {
		this.activo = activo;
	}
	
	
}
