package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

@Entity
@Table(name = "EMBARQUE_CATRACA_RODOVIARIA")
@SequenceGenerator(name = "EMBARQUE_CATRACA_ROD_SEQ", sequenceName = "EMBARQUE_CATRACA_ROD_SEQ", allocationSize = 1)
public class EmbarqueCatracaRodoviaria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name = "EMBARQUECATRACARODOVIARIA_ID")
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "EMBARQUE_CATRACA_ROD_SEQ")
	private Integer embarqueCatracaRodoviariaId;

	@Column
	private Boolean activo;

	@ManyToOne(targetEntity = Empresa.class)
	@JoinColumn(name = "EMPRESA_ID")
	private Empresa empresa;

	@ManyToOne(targetEntity = Parada.class)
	@JoinColumn(name = "PARADA_ID")
	private Parada parada;

	@Column
	private Integer sequenciaRod;

	@Column(name = "EMPRESAROD_ID")
	private Integer empresaRod;

	@ManyToOne(targetEntity = Usuario.class)
	@JoinColumn(name = "USUARIO_ID")
	private Usuario usuario;

	@Column
	private Date fecModif;

	public Integer getEmbarqueCatracaRodoviariaId() {
		return embarqueCatracaRodoviariaId;
	}

	public void setEmbarqueCatracaRodoviariaId(Integer embarqueCatracaRodoviariaId) {
		this.embarqueCatracaRodoviariaId = embarqueCatracaRodoviariaId;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Empresa getEmpresa() {
		return empresa;
	}

	public void setEmpresa(Empresa emrpesa) {
		this.empresa = emrpesa;
	}

	public Parada getParada() {
		return parada;
	}

	public void setParada(Parada parada) {
		this.parada = parada;
	}

	public Integer getSequenciaRod() {
		return sequenciaRod;
	}

	public void setSequenciaRod(Integer sequenciaRod) {
		this.sequenciaRod = sequenciaRod;
	}

	public Integer getEmpresaRod() {
		return empresaRod;
	}

	public void setEmpresaRod(Integer empresaRod) {
		this.empresaRod = empresaRod;
	}

	public Usuario getUsuario() {
		return usuario;
	}

	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}

	public Date getFecModif() {
		return fecModif;
	}

	public void setFecModif(Date fecModif) {
		this.fecModif = fecModif;
	}

}
