package com.rjconsultores.ventaboletos.entidad;

import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

import br.com.rjconsultores.auditador.annotations.NaoAuditar;
import br.com.rjconsultores.auditador.interfaces.Auditavel;

@Entity
@SequenceGenerator(name = "ESQUEMA_CORRIDA_EMB_DESEM_SEQ", sequenceName = "ESQUEMA_CORRIDA_EMB_DESEM_SEQ", allocationSize = 1)
@Table(name = "ESQUEMA_CORRIDA_EMBRQ_DESEMBRQ")
public class EsquemaCorridaEmbarqueDesembarque implements java.io.Serializable, Auditavel<EsquemaCorridaEmbarqueDesembarque> {

	private static final long serialVersionUID = -6308295160991190414L;

	@Id
	@Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "ESQUEMA_CORRIDA_EMB_DESEM_SEQ")
	@Column(name = "ESQUEMACORRIDAEMBRQDESEMBRQ_ID", unique = true, nullable = false, precision = 7, scale = 0)
	private Integer esquemaCorridaEmbarqueDesembarqueId;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ESQUEMACORRIDA_ID", nullable = false)
	@NaoAuditar
	private EsquemaCorrida esquemaCorrida;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "PARADA_ID", nullable = false)
	private Parada parada;

	@Column(name = "ACTIVO", precision = 1, scale = 0)
	private Boolean activo;

	@Temporal(TemporalType.DATE)
	@Column(name = "FECMODIF", length = 7)
	private Date fecmodif;

	@Column(name = "USUARIO_ID", precision = 7, scale = 0)
	private Integer usuarioId;
	
	@Column(name = "EMBARQUE", precision = 1, scale = 0)
	private Boolean embarque;
	
	@Column(name = "DESEMBARQUE", precision = 1, scale = 0)
	private Boolean desembarque;

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "PARADA_EMB_DES_ID")
	private Parada localDesembarqueEmbarque;
	
	@Column(name = "IS_VISUALIZAR_NA_API", precision = 1, scale = 0)
	private Boolean isVisualizarNaAPI;

	@Transient
	@NaoAuditar
	private EsquemaCorridaEmbarqueDesembarque esquemaCorridaEmbarqueDesembarqueClone;
	
	public EsquemaCorridaEmbarqueDesembarque() {
	}

	public EsquemaCorridaEmbarqueDesembarque(Integer esquemacorridaembrqdesembrqId, EsquemaCorrida esquemaCorrida,
			Parada parada) {
		this.esquemaCorridaEmbarqueDesembarqueId = esquemacorridaembrqdesembrqId;
		this.esquemaCorrida = esquemaCorrida;
		this.parada = parada;
	}

	public EsquemaCorridaEmbarqueDesembarque(Integer esquemacorridaembrqdesembrqId, EsquemaCorrida esquemaCorrida, Parada parada,
			Boolean activo, Date fecmodif, Integer usuarioId) {
		this.esquemaCorridaEmbarqueDesembarqueId = esquemacorridaembrqdesembrqId;
		this.esquemaCorrida = esquemaCorrida;
		this.parada = parada;
		this.activo = activo;
		this.fecmodif = fecmodif;
		this.usuarioId = usuarioId;
	}

	public Integer getEsquemaCorridaEmbarqueDesembarqueId() {
		return this.esquemaCorridaEmbarqueDesembarqueId;
	}

	public void setEsquemaCorridaEmbarqueDesembarqueId(Integer esquemaCorridaEmbarqueDesembarqueId) {
		this.esquemaCorridaEmbarqueDesembarqueId = esquemaCorridaEmbarqueDesembarqueId;
	}

	public EsquemaCorrida getEsquemaCorrida() {
		return this.esquemaCorrida;
	}

	public void setEsquemaCorrida(EsquemaCorrida esquemaCorrida) {
		this.esquemaCorrida = esquemaCorrida;
	}

	public Parada getParada() {
		return this.parada;
	}

	public void setParada(Parada parada) {
		this.parada = parada;
	}

	public Boolean getActivo() {
		return this.activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return this.fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return this.usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public Boolean getEmbarque() {
		return embarque;
	}

	public void setEmbarque(Boolean embarque) {
		this.embarque = embarque;
	}

	public Boolean getDesembarque() {
		return desembarque;
	}

	public void setDesembarque(Boolean desembarque) {
		this.desembarque = desembarque;
	}
	
	@Override
	public String toString() {
		return parada != null ? parada.getDescparada() : "";
	}

	public Parada getLocalDesembarqueEmbarque() {
		return localDesembarqueEmbarque;
	}

	public void setLocalDesembarqueEmbarque(Parada localDesembarqueEmbarque) {
		this.localDesembarqueEmbarque = localDesembarqueEmbarque;
	}

	public Boolean getIsVisualizarNaAPI() {
		return isVisualizarNaAPI;
	}

	public void setIsVisualizarNaAPI(Boolean isVisualizarNaAPI) {
		this.isVisualizarNaAPI = isVisualizarNaAPI;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((getEsquemaCorridaEmbarqueDesembarqueId() == null) ? 0 : getEsquemaCorridaEmbarqueDesembarqueId().hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof EsquemaCorridaEmbarqueDesembarque))
			return false;
		EsquemaCorridaEmbarqueDesembarque other = (EsquemaCorridaEmbarqueDesembarque) obj;
		if (getEsquemaCorridaEmbarqueDesembarqueId() == null) {
			if (other.getEsquemaCorridaEmbarqueDesembarqueId() != null)
				return false;
		} else if (!getEsquemaCorridaEmbarqueDesembarqueId().equals(other.getEsquemaCorridaEmbarqueDesembarqueId()))
			return false;
		return true;
	}
	
	@Override
	public void clonar() throws CloneNotSupportedException {
		esquemaCorridaEmbarqueDesembarqueClone = new EsquemaCorridaEmbarqueDesembarque();
		esquemaCorridaEmbarqueDesembarqueClone = (EsquemaCorridaEmbarqueDesembarque) this.clone();
		
	}

	@Override
	public EsquemaCorridaEmbarqueDesembarque getCloneObject() throws CloneNotSupportedException {
		return esquemaCorridaEmbarqueDesembarqueClone;
	}

	@Override
	public String getTextoInclusaoExclusao() {
		return String.format("ID [%s] - Embarque [%s] - Desemb. [%s]",
				getEsquemaCorridaEmbarqueDesembarqueId(), getParada() != null ? getParada().getDescparada() : "",
				getEsquemaCorridaEmbarqueDesembarqueId(), getLocalDesembarqueEmbarque() != null ? getLocalDesembarqueEmbarque().getDescparada() : "");
	}	

}
