package com.rjconsultores.ventaboletos.entidad;

import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
@Entity
@SequenceGenerator(name = "FISCAL_TOTNAOFISCAL_EMP_SEQ", sequenceName = "FISCAL_TOTNAOFISCAL_EMP_SEQ", allocationSize = 1)
@Table(name = "FISCAL_TOTNAOFISCAL_EMPRESA")
public class FiscalTotnaofiscalEmpresa {

	@Id
	@Basic(optional = false)
	@Column(name = "FISCALTOTNAOFISCAL_ID")
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "FISCAL_TOTNAOFISCAL_EMP_SEQ")
	private Long fiscaltotnaofiscalId;
	@Column(name = "TIPOTOTALIZADOR")
	private String tipototalizador;
	@Column(name = "DESCRICAO")
	private String descricao;
	@ManyToOne
	@JoinColumn(name = "EMPRESA_ID")
	private Empresa empresa;
	@ManyToOne
	@JoinColumn(name = "TIPOEVENTOEXTRA_ID")
	private TipoEventoExtra tipoeventoextra;
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	
	
	public String getTipototalizador() {
		return tipototalizador;
	}
	public void setTipototalizador(String tipototalizador) {
		this.tipototalizador = tipototalizador;
	}
	public String getDescricao() {
		return descricao;
	}
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public Empresa getEmpresa() {
		return empresa;
	}
	public void setEmpresa(Empresa empresa) {
		this.empresa = empresa;
	}
	public TipoEventoExtra getTipoeventoextra() {
		return tipoeventoextra;
	}
	public void setTipoeventoextra(TipoEventoExtra tipoeventoextra) {
		this.tipoeventoextra = tipoeventoextra;
	}
	public Date getFecmodif() {
		return fecmodif;
	}
	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}
	public Integer getUsuarioId() {
		return usuarioId;
	}
	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}
	public Boolean getActivo() {
		return activo;
	}
	public void setActivo(Boolean activo) {
		this.activo = activo;
	}
	public Long getFiscaltotnaofiscalId() {
		return fiscaltotnaofiscalId;
	}
	public void setFiscaltotnaofiscalId(Long fiscaltotnaofiscalId) {
		this.fiscaltotnaofiscalId = fiscaltotnaofiscalId;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((empresa == null) ? 0 : empresa.hashCode());
		result = prime * result + ((tipototalizador == null) ? 0 : tipototalizador.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		FiscalTotnaofiscalEmpresa other = (FiscalTotnaofiscalEmpresa) obj;
		if (empresa == null) {
			if (other.empresa != null)
				return false;
		} else if (!empresa.equals(other.empresa))
			return false;
		if (tipototalizador == null) {
			if (other.tipototalizador != null)
				return false;
		} else if (!tipototalizador.equals(other.tipototalizador))
			return false;
		return true;
	}
	
	
}
