package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "GP_PRICING_ESPEC_OCUP_SEQ", sequenceName = "GP_PRICING_ESPEC_OCUP_SEQ", allocationSize = 1)
@Table(name = "GP_PRICING_ESPEC_OCUPACION")
public class GP_PricingEspecificoOcupacion implements Serializable, Cloneable {

	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "GP_PRICING_ESPEC_OCUP_SEQ")
	@Column(name = "PRICINGESPECIFICOOCUPACION_ID")
	private Integer pricingEspecificoOcupacionId;
	
	@Column(name = "OCUPACIONINICIAL")
	private BigDecimal ocupacioninicial;
	
	@Column(name = "OCUPACIONFINAL")
	private BigDecimal ocupacionfinal;
	
	@Column(name = "TARIFA")
	private BigDecimal tarifa;
	
	@Basic(optional = false)
	@Column(name = "ACTIVO")
	private Boolean activo;
	
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	
	@Basic(optional = false)
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	
	@Column(name = "DESCUENTO")
	private BigDecimal descuento;

	@JoinColumn(name = "PRICINGESPECIFICO_ID", referencedColumnName = "PRICINGESPECIFICO_ID")
	@ManyToOne
	private GP_PricingEspecifico pricingEspecifico;

	public GP_PricingEspecificoOcupacion() {
		super();
	}

	public GP_PricingEspecificoOcupacion(BigDecimal ocupacioninicial, BigDecimal ocupacionfinal, BigDecimal tarifa, Boolean activo, Date fecmodif, Integer usuarioId, BigDecimal descuento, GP_PricingEspecifico pricingEspecifico) {
		super();
		this.ocupacioninicial = ocupacioninicial;
		this.ocupacionfinal = ocupacionfinal;
		this.tarifa = tarifa;
		this.activo = activo;
		this.fecmodif = fecmodif;
		this.usuarioId = usuarioId;
		this.descuento = descuento;
		this.pricingEspecifico = pricingEspecifico;
	}

	public Integer getPricingEspecificoOcupacionId() {
		return pricingEspecificoOcupacionId;
	}

	public void setPricingEspecificoOcupacionId(Integer pricingEspecificoOcupacionId) {
		this.pricingEspecificoOcupacionId = pricingEspecificoOcupacionId;
	}

	public BigDecimal getOcupacioninicial() {
		return ocupacioninicial;
	}

	public void setOcupacioninicial(BigDecimal ocupacioninicial) {
		this.ocupacioninicial = ocupacioninicial;
	}

	public BigDecimal getOcupacionfinal() {
		return ocupacionfinal;
	}

	public void setOcupacionfinal(BigDecimal ocupacionfinal) {
		this.ocupacionfinal = ocupacionfinal;
	}

	public BigDecimal getTarifa() {
		return tarifa;
	}

	public void setTarifa(BigDecimal tarifa) {
		this.tarifa = tarifa;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public GP_PricingEspecifico getPricingEspecifico() {
		return pricingEspecifico;
	}

	public void setPricingEspecifico(GP_PricingEspecifico pricingEspecifico) {
		this.pricingEspecifico = pricingEspecifico;
	}
	
	public BigDecimal getDescuento() {
		return descuento;
	}

	public void setDescuento(BigDecimal descuento) {
		this.descuento = descuento;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((pricingEspecificoOcupacionId == null) ? 0 : pricingEspecificoOcupacionId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		GP_PricingEspecificoOcupacion other = (GP_PricingEspecificoOcupacion) obj;
		if (pricingEspecificoOcupacionId == null) {
			if (other.pricingEspecificoOcupacionId != null)
				return false;
		} else if (!pricingEspecificoOcupacionId.equals(other.pricingEspecificoOcupacionId))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return " [OCUPACAO_INICIAL=" + ocupacioninicial + ", OCUPACAO_FINAL=" + ocupacionfinal + ", TARIFA=" + tarifa + ", DESCONTO=" + descuento + "]";
	}

	@Override
	protected Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
