package com.rjconsultores.ventaboletos.entidad;

import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "ORGAO_COMPROVANTECUSTOMIZADO_SEQ", sequenceName = "ORGAO_COMPROVANTECUSTOMIZADO_SEQ", allocationSize = 1)
@Table(name = "ORGAO_COMPROVANTECUSTOMIZADO")
public class OrgaoComprovanteCustomizado {
	
	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "ORGAO_COMPROVANTECUSTOMIZADO_SEQ")
	@Column(name = "ORGAOCOMPROVANTECUSTOMIZADO_ID")
	private Integer orgaoComprovanteCustomizadoId;
	@Column(name = "TIPOCOMPROVANTE_ID")
	private Integer tipoComprovanteId;
	@Column(name = "CVE_TIPOCOMPROVANTE")	
	private String cveTipoComprovante; 
	@OneToOne
	@JoinColumn(name = "ORGAOCONCEDENTE_ID")
	private OrgaoConcedente orgaoConcedente;	
	@Column(name = "TXTCOMPROVANTECUSTOMIZADO")
	private String txtComprovanteCustomizado;
	
	@Column(name = "ACTIVO")
	private Boolean activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	
	
	public Integer getOrgaoComprovanteCustomizadoId() {
		return orgaoComprovanteCustomizadoId;
	}
	public void setOrgaoComprovanteCustomizadoId(Integer orgaoComprovanteCustomizadoId) {
		this.orgaoComprovanteCustomizadoId = orgaoComprovanteCustomizadoId;
	}
	public Integer getTipoComprovanteId() {
		return tipoComprovanteId;
	}
	public void setTipoComprovanteId(Integer tipoComprovanteId) {
		this.tipoComprovanteId = tipoComprovanteId;
	}
	public String getCveTipoComprovante() {
		return cveTipoComprovante;
	}
	public void setCveTipoComprovante(String cveTipoComprovante) {
		this.cveTipoComprovante = cveTipoComprovante;
	}
	public OrgaoConcedente getOrgaoConcedente() {
		return orgaoConcedente;
	}
	public void setOrgaoConcedente(OrgaoConcedente orgaoConcedente) {
		this.orgaoConcedente = orgaoConcedente;
	}
	public Boolean getActivo() {
		return activo;
	}
	public void setActivo(Boolean activo) {
		this.activo = activo;
	}
	public Date getFecmodif() {
		return fecmodif;
	}
	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}
	public Integer getUsuarioId() {
		return usuarioId;
	}
	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}
	public String getTxtComprovanteCustomizado() {
		return txtComprovanteCustomizado;
	}
	public void setTxtComprovanteCustomizado(String txtComprovanteCustomizado) {
		this.txtComprovanteCustomizado = txtComprovanteCustomizado;
	};
	
}
