/**
 * 
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * @author Thiago
 *
 */
@Entity
@SequenceGenerator(name = "PRECIO_VENTAJA_SEQ", sequenceName = "PRECIO_VENTAJA_SEQ", allocationSize = 1)
@Table(name = "PRECIO_VENTAJA")
public class PrecioVentaja implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "PRECIO_VENTAJA_SEQ")
	@Column(name = "PRECIOVENTAJA_ID")
	private Integer precioVentajaId;
	
	@OneToOne
	@JoinColumn(name = "RUTA_ORIGINAL_ID", referencedColumnName = "RUTA_ID")
	private Ruta rutaOriginalId;
	
	@OneToOne
	@JoinColumn(name = "ORIGEN_ORIGINAL_ID", referencedColumnName = "PARADA_ID")
	private Parada origenOriginalId;
	
	@OneToOne
	@JoinColumn(name = "DESTINO_ORIGINAL_ID", referencedColumnName = "PARADA_ID")
	private Parada destinoOriginalId;
	
	@Column(name = "INDPREFIXOORIGEN")
	private Boolean indPrefixoOrigen;
	
	@Column(name = "FECINICIO")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fechaInicio;
	
	@Column(name = "FECFINAL")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fechaFinal;
	
	@OneToOne
	@JoinColumn(name = "RUTA_PRECIO_ID", referencedColumnName = "RUTA_ID")
	private Ruta rutaPrecioId;
	
	@Column(name = "CORRIDA_ID")
	private Integer corridaId;
	
	@OneToOne
	@JoinColumn(name = "ORIGEN_PRECIO_ID", referencedColumnName = "PARADA_ID")
	private Parada origenPrecioId;
	
	@OneToOne
	@JoinColumn(name = "DESTINO_PRECIO_ID", referencedColumnName = "PARADA_ID")
	private Parada destinoPrecioId;
	
	@Column(name = "ACTIVO")
	private Boolean activo;
	
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	
	@Column(name = "INDCLASSEAPROVEITAMENTO")
	private Boolean indClasseAproveitamento;

	public Integer getPrecioVentajaId() {
		return precioVentajaId;
	}

	public void setPrecioVentajaId(Integer precioVentajaId) {
		this.precioVentajaId = precioVentajaId;
	}

	public Ruta getRutaOriginalId() {
		return rutaOriginalId;
	}

	public void setRutaOriginalId(Ruta rutaOriginalId) {
		this.rutaOriginalId = rutaOriginalId;
	}

	public Parada getOrigenOriginalId() {
		return origenOriginalId;
	}

	public void setOrigenOriginalId(Parada origenOriginalId) {
		this.origenOriginalId = origenOriginalId;
	}

	public Parada getDestinoOriginalId() {
		return destinoOriginalId;
	}

	public void setDestinoOriginalId(Parada destinoOriginalId) {
		this.destinoOriginalId = destinoOriginalId;
	}

	public Boolean getIndPrefixoOrigen() {
		return indPrefixoOrigen;
	}

	public void setIndPrefixoOrigen(Boolean indPrefixoOrigen) {
		this.indPrefixoOrigen = indPrefixoOrigen;
	}

	public Date getFechaInicio() {
		return fechaInicio;
	}

	public void setFechaInicio(Date fechaInicio) {
		this.fechaInicio = fechaInicio;
	}

	public Date getFechaFinal() {
		return fechaFinal;
	}

	public void setFechaFinal(Date fechaFinal) {
		this.fechaFinal = fechaFinal;
	}

	public Ruta getRutaPrecioId() {
		return rutaPrecioId;
	}

	public void setRutaPrecioId(Ruta rutaPrecioId) {
		this.rutaPrecioId = rutaPrecioId;
	}

	public Integer getCorridaId() {
		return corridaId;
	}

	public void setCorridaId(Integer corridaId) {
		this.corridaId = corridaId;
	}

	public Parada getOrigenPrecioId() {
		return origenPrecioId;
	}

	public void setOrigenPrecioId(Parada origenPrecioId) {
		this.origenPrecioId = origenPrecioId;
	}

	public Parada getDestinoPrecioId() {
		return destinoPrecioId;
	}

	public void setDestinoPrecioId(Parada destinoPrecioId) {
		this.destinoPrecioId = destinoPrecioId;
	}

	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public Boolean getIndClasseAproveitamento() {
		return indClasseAproveitamento == null ? false : indClasseAproveitamento;
	}

	public void setIndClasseAproveitamento(Boolean indClasseAproveitamento) {
		this.indClasseAproveitamento = indClasseAproveitamento;
	}	
}
