/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * 
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PRICING_RUTA_SEQ", sequenceName = "PRICING_RUTA_SEQ", allocationSize = 1)
@Table(name = "PRICING_RUTA")
public class PricingRuta implements Serializable {

	private static final long serialVersionUID = 1L;
	@Id
	@Basic(optional = false)
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "PRICING_RUTA_SEQ")
	@Column(name = "PRICINGRUTA_ID")
	private Integer pricingrutaId;
	@Column(name = "ACTIVO")
	private Integer activo;
	@Column(name = "FECMODIF")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fecmodif;
	@Column(name = "USUARIO_ID")
	private Integer usuarioId;
	@JoinColumn(name = "RUTA_ID", referencedColumnName = "RUTA_ID")
	@ManyToOne
	private Ruta ruta;
	@JoinColumn(name = "PRICING_ID", referencedColumnName = "PRICING_ID")
	@ManyToOne
	private Pricing pricing;

	public PricingRuta() {
	}

	public PricingRuta(Integer pricingrutaId) {
		this.pricingrutaId = pricingrutaId;
	}

	public Integer getPricingrutaId() {
		return pricingrutaId;
	}

	public void setPricingrutaId(Integer pricingrutaId) {
		this.pricingrutaId = pricingrutaId;
	}

	public Integer getActivo() {
		return activo;
	}

	public void setActivo(Integer activo) {
		this.activo = activo;
	}

	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}

	public Ruta getRuta() {
		return ruta;
	}

	public void setRuta(Ruta ruta) {
		this.ruta = ruta;
	}

	public Pricing getPricing() {
		return pricing;
	}

	public void setPricing(Pricing pricing) {
		this.pricing = pricing;
	}

	@Override
	public int hashCode() {
		int hash = 0;
		hash += (pricingrutaId != null ? pricingrutaId.hashCode() : 0);
		return hash;
	}

	@Override
	public boolean equals(Object object) {
		if (!(object instanceof PricingRuta)) {
			return false;
		}
		PricingRuta other = (PricingRuta) object;
		if ((this.pricingrutaId == null && other.pricingrutaId != null) || (this.pricingrutaId != null && !this.pricingrutaId.equals(other.pricingrutaId))) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return "entidad.test.PricingRuta[pricingrutaId=" + pricingrutaId + "]";
	}
}
