package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@SequenceGenerator(name = "TIPO_INFORMATIVO_SEQ", sequenceName = "TIPO_INFORMATIVO_SEQ", allocationSize = 1)
@Table(name = "TIPO_INFORMATIVO")
public class TipoInformativoComissao implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "TIPO_INFORMATIVO_SEQ")
    @Column(name = "TIPOINFORMATIVO_ID")
    private Short tipoinformativoId;
    @Column(name = "DESCTIPO")
    private String desctipo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @Column(name = "ACTIVO")
    private Boolean activo;
    
    public Short getTipoinformativoId() {
		return tipoinformativoId;
	}

	public void setTipoinformativoId(Short tipoinformativoId) {
		this.tipoinformativoId = tipoinformativoId;
	}

	public String getDesctipo() {
        return desctipo;
    }

    public void setDesctipo(String desctipo) {
        this.desctipo = desctipo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tipoinformativoId != null ? tipoinformativoId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof TipoInformativoComissao)) {
            return false;
        }
        TipoInformativoComissao other = (TipoInformativoComissao) object;
        if ((this.tipoinformativoId == null && other.tipoinformativoId != null) || (this.tipoinformativoId != null && !this.tipoinformativoId.equals(other.tipoinformativoId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return desctipo;
    }
}
