package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConexionRutaExcepcionPtoVtaDAO;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaConf;
import com.rjconsultores.ventaboletos.entidad.ConexionRutaExcepcionPtoVta;
import com.rjconsultores.ventaboletos.service.ConexionRutaExcepcionPtoVtaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("conexionRutaExcepcionPtoVtaService")
public class ConexionRutaExcepcionPtoVtaServiceImpl implements ConexionRutaExcepcionPtoVtaService {

	@Autowired
	private ConexionRutaExcepcionPtoVtaDAO conexionRutaExcepcionPtoVtaDAO;

	@Override
	public void gerarConexiones() {
		// TODO Auto-generated method stub

	}

	@Override
	@Transactional
	public ConexionRutaExcepcionPtoVta suscribir(ConexionRutaExcepcionPtoVta conexionRutaPtoVta) {

		conexionRutaPtoVta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		conexionRutaPtoVta.setFecmodif(Calendar.getInstance().getTime());
		conexionRutaPtoVta.setActivo(Boolean.TRUE);

		return conexionRutaExcepcionPtoVtaDAO.actualizacion(conexionRutaPtoVta);
	}

	@Override
	public ConexionRutaExcepcionPtoVta actualizacion(ConexionRutaExcepcionPtoVta conexion) {
		return null;
	}

	@Override
	@Transactional
	public void borrar(ConexionRutaExcepcionPtoVta entidad) {

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);
//		conexionRutaExcepcionPtoVtaDAO.update(entidad);
		conexionRutaExcepcionPtoVtaDAO.actualizacion(entidad);

	}

	@Override
	@Transactional
	public void borrar(List<ConexionRutaExcepcionPtoVta> lsConexion) {
		for (ConexionRutaExcepcionPtoVta conexionRutaExcepcionPtoVta : lsConexion) {
			borrar(conexionRutaExcepcionPtoVta);
		}
	}

	@Override
	@Transactional
	public void suscribirTodos(List<ConexionRutaExcepcionPtoVta> conexionRutaExcepcionPtoVtas) {

		for (ConexionRutaExcepcionPtoVta conexion : conexionRutaExcepcionPtoVtas) {
			suscribir(conexion);
		}

	}

	@Override
	public List<ConexionRutaExcepcionPtoVta> buscarPorConexionConf(ConexionRutaConf conexionRutaConf) {
		return conexionRutaExcepcionPtoVtaDAO.buscarPorConexionConf(conexionRutaConf);
	}

}
